import ApproximateCurves from 'approximate-curve'

var getY = function (points, samples, width, height) {
	samples = samples !== undefined ? samples : 300000
		width = width !== undefined ? width : 100
		height = height !== undefined ? height : 100

		points = ApproximateCurves(points)
		var xSamples = []
		var ySamples = []
		var k = points.length - 1
		var delta = 1 / samples
		var t = 0

		var firstPoint = points[0]

		xSamples.push(firstPoint.x / width)
		ySamples.push(1 - (firstPoint.y / height))

		for (var i = 0; i < samples; i++) {
			t += delta

			var p = t * k
				var f = Math.floor(p)
				var dt = p - f
				var m = f + 1 > k ? k : f + 1

				var p1 = points[f]
				var p2 = points[m]

				xSamples.push((p1.x + (p2.x - p1.x) * dt) / width)
				ySamples.push(1 - ((p1.y + (p2.y - p1.y) * dt) / height))
		}

		var lastPoint = points[points.length - 1]
		var lastX = lastPoint.x / width
		var lastY = 1 - (lastPoint.y / height)

		xSamples.push(lastX)
		ySamples.push(lastY)

		var isEndAtOne = lastY === 1

		return function (t) {
		for (var n = 0, len = xSamples.length; n < len; n++) {
			if (t === xSamples[n] || (xSamples[n] < t && xSamples[n + 1] > t)) {
				return ySamples[n]
			}
		}
		return t === 1 ? isEndAtOne ? t : lastY : isEndAtOne ? t : ySamples[(t * ySamples.length - 1) | 0]
	}
}

function OwnEasing(d, accuracy, width, height) {
	return getY(d, accuracy ? 100 * accuracy : 300, width, height)
}

// To-Do: Interpolation drawing support
OwnEasing.Value = function (d, accuracy, width, height) {
	var points = ApproximateCurves(d)
		return function (arr, t) {
		var l = arr.length - 1
			var k = t * l
			var i = Math.floor(k)
			var dt = k - i
			var m = i + 1 > l ? l : i + 1
			var py = (getPointAtElapsed(points, t).y / 100) - 0.5
			return arr[i] + (arr[m] - arr[i]) * py
	}
}

export default OwnEasing
